// Test `VecScatter', `VecScatterMsk' schedules

//   !hpf$ processors q(2, 3)
// 
//   !hpf$ template s(4, 10)
//   !hpf$ distribute s(block, block) onto q
// 
//   integer b(5, 5)
//   !hpf$ align b(*, j) with s(1, 8 - j)
// 
//   integer u(5), v(5)
//   !hpf$ align u(i) with b(i, *)
//   !hpf$ align v(j) with b(*, j)
// 
//   !hpf$ processors p(2, 3)
// 
//   !hpf$ template t(6, 3)
//   !hpf$ distribute t(cyclic, block) onto p
// 
//   integer a(6, 6)
// 
//   !hpf$ align a(i, *) with t(i, *)
// 
//   integer i, j
// 
//   do i = 1, 5
//     do j = 1, 5
//       b(i, j) = 10 * (i - 1) + (j - 1)
//     enddo
//   enddo
// 
//   do i = 1, 5
//     u(i) = 1 + mod((i - 1) * 11, 6)
//   enddo
// 
//   do j = 1, 5
//     v(j) = 1 + mod((j - 1) + 3, 6)
//   enddo
// 
//   do i = 1, 6
//     do j = 1, 6
//       a(i, j) = 0.0
//     enddo
//   enddo
// 
//   a(u, v) = b
// 
//   do i = 1, 6
//     do j = 1, 6
//       print "(2i3, i10)", i - 1, j - 1, a(i, j)
//     enddo
//   enddo
// 
// end


/*
 * File         : test0.hpj
 * Author       : Qiang Zheng
 * Created      : Wed Oct 14 1998
 * Revision     : $Revision: 1.0 $
 * Updated      : $Date: 1998/10/14 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import hpjava.spmd.*;
import hpjava.spmd.adlib.*;
import hpjava.lang.*;

class test8{
  static SpmdEnv spmd;
  static Procs2 p;
  static BlockRange x,y;
  static Array2ddF a;

}

class test6 {
  static SpmdEnv spmd;
  static Procs2 p;
  static BlockRange x,y;
  static Array2ddI a,b;
  static Range z; 
  // Range z = new CyclicRange (10, p.dim(0)).subrng(6, 1);

  public static void main(String argv[]) {
    spmd = new SpmdEnv (argv);

    p=new Procs2(2,2);

    if (p.on()) {

      x = new BlockRange (6, p.dim(0));
      y = new BlockRange (4, p.dim(1));

      a = new Array2ddI(spmd.apg, x, y);

      z = new CyclicRange (10, p.dim(0)).subrng(6, 1);

      Array2ddI b = new Array2ddI(spmd.apg,z, y);
      
      Index i = new Index (x);
      Index j = new Index (y);

      i.dim().over();
      for (i.begin(); i.test(); i.next()) {
	j.dim().over();
	for (j.begin(); j.test(); j.next()) {
	  a.dat()[a.pos(i, j)]= 100*x.idx(i) + 10*y.idx(j);
	  //	  System.out.println(a.dat()[a.pos(i,j)]);
	} j.dim().revo();
      } i.dim().revo();

      //      Adlib.aprintf("%3R0%3R1%10d\n", a);

      Adlib.remap(b, a);

      Adlib.aprintf("%3R0%3R1%10d\n", b);

    } p.no();

    spmd.finalize();

  }
}









































